<?php

namespace Modules\Sd\Http\Controllers;

use Modules\Pp\Entities\CustomerOrder;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;

class CustomerOrderStatusListController extends Controller
{
    public function allCustomerOrder($year, $month)
    {
        try {
            if (strlen($month) == 1) {
                $date = $year . "-0" . $month . "%";
            } else {
                $date = $year . "-" . $month . "%";
            }

            $customer_orders = CustomerOrder::where('date', 'LIKE', $date)->orderBy('order_id', 'DESC')->get();
            $responseBody = $this->responseBody(true, "CustomerOrderListController", "allCustomerOrder", $customer_orders);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "allCustomerOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function shipping_status(Request $request)
    {

        try {
            $id = $request->get('id');
            $status = $request->get('status');
            $order = CustomerOrder::find($id);
            if ($order) {
                $order->shipping_status = $status;
                $order->update();
            }

            $responseBody = $this->responseBody(true, "CustomerOrderListController", "shipping_status", true);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
